CREATE OR REPLACE PACKAGE ACT_SALUD as

PROCEDURE CIUDADANOS_Add(
                          p_idpersona          IN     CIUDADANOS.IDPERSONA%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 );

PROCEDURE CIUDADANOS_Add(
                          p_ide                IN     PERSONAS.IDE%TYPE
                         ,p_nombre             IN     PERSONAS.NOMBRE%TYPE
                         ,p_apellido1          IN     PERSONAS.APELLIDO1%TYPE
                         ,p_apellido2          IN     PERSONAS.APELLIDO2%TYPE
                         ,p_fechanac           IN     PERSONAS.FECHANAC%TYPE
                         ,p_codpais            IN     PERSONAS.CODPAIS%TYPE
                         ,p_sexo               IN     PERSONAS.SEXO%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 );
                         
PROCEDURE CIUDADANOS_Update(
                          p_id                 IN     CIUDADANOS.ID%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 );
                         
PROCEDURE CIUDADANOS_Update(
                          p_idpersona          IN     CIUDADANOS.IDPERSONA%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 );
                         
PROCEDURE CIUDADANOS_Delete(
                          p_id                 IN     CIUDADANOS.ID%TYPE
                         ,p_fechabaj           IN     CIUDADANOS.FECHABAJ%TYPE
                         ,p_idmotbaj           IN     CIUDADANOS.IDMOTBAJ%TYPE
                         ,p_RSP                OUT    VARCHAR2 );
                         
PROCEDURE CIUDADANOS_Delete(
                          p_idpersona          IN     CIUDADANOS.IDPERSONA%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_fechabaj           IN     CIUDADANOS.FECHABAJ%TYPE
                         ,p_idmotbaj           IN     CIUDADANOS.IDMOTBAJ%TYPE
                         ,p_RSP                OUT    VARCHAR2 );

PROCEDURE CENTROS_SALUD_Add(
                          p_codpais            IN     CENTROS_SALUD.CODPAIS%TYPE
                         ,p_codcentro          IN     CENTROS_SALUD.CODCENTRO%TYPE
                         ,p_nombre             IN     CENTROS_SALUD.NOMBRE%TYPE
                         ,p_telefono           IN     CENTROS_SALUD.TELEFONO%TYPE
                         ,p_correo             IN     CENTROS_SALUD.CORREO%TYPE
                         ,p_RSP                OUT    VARCHAR2 );

PROCEDURE CENTROS_SALUD_Update(
                          p_id                 IN     CENTROS_SALUD.ID%TYPE
                         ,p_nombre             IN     CENTROS_SALUD.NOMBRE%TYPE
                         ,p_telefono           IN     CENTROS_SALUD.TELEFONO%TYPE
                         ,p_correo             IN     CENTROS_SALUD.CORREO%TYPE
                         ,p_RSP                OUT    VARCHAR2 );
                         
PROCEDURE CENTROS_SALUD_Delete(
                          p_id                 IN     CENTROS_SALUD.ID%TYPE
                         ,p_fechabaj           IN     CENTROS_SALUD.FECHABAJ%TYPE
                         ,p_RSP                OUT    VARCHAR2 );

PROCEDURE ACT_DIARIA_Act(
                          p_idciu      IN     ACT_DIARIA.IDCIU%TYPE
                         ,p_fecha      IN     ACT_DIARIA.FECHA%TYPE
                         ,p_pasos      IN     ACT_DIARIA.PASOS%TYPE
                         ,p_calorias   IN     ACT_DIARIA.CALORIAS%TYPE
                         ,p_hpocact    IN     ACT_DIARIA.HPOCACT%TYPE
                         ,p_RSP        OUT    VARCHAR2 );                         

PROCEDURE HIS_SALUD_Act(
                          p_idciu      IN     HIS_SALUD.IDCIU%TYPE
                         ,p_anio       IN     HIS_SALUD.ANIO%TYPE
                         ,p_visitasmed IN     HIS_SALUD.VISITASMED%TYPE
                         ,p_enflevs    IN     HIS_SALUD.ENFLEVS%TYPE
                         ,p_id         OUT    HIS_SALUD.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 );

PROCEDURE HISSALUD_ENF_Add(
                          p_idhis      IN     HIS_SALUD.ID%TYPE
                         ,p_idenf      IN     ENFERMEDADES.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 );
                         
PROCEDURE ACT_DIARIA_Delete(
                          p_idciu      IN     ACT_DIARIA.IDCIU%TYPE
                         ,p_fecha      IN     ACT_DIARIA.FECHA%TYPE
                         ,p_RSP        OUT    VARCHAR2 );                         

PROCEDURE HIS_SALUD_Delete(
                          p_id         IN     HIS_SALUD.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 );

PROCEDURE HISSALUD_ENF_Delete(
                          p_idhis      IN     HIS_SALUD.ID%TYPE
                         ,p_idenf      IN     ENFERMEDADES.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 );
                         
PROCEDURE HISSALUD_ENF_Delete(
                          p_idhis      IN     HIS_SALUD.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 );

END ACT_SALUD;
/
CREATE OR REPLACE PACKAGE BODY ACT_SALUD AS

  /* ***************************************************************************
   *  Descripcin: Realiza el alta de un ciudadano en la BD
   *  Parametros entrada (datos a insertar): 
   *    p_idpersona - Identificacin BD de persona
   *    p_idcentro  - Identificacin BD de centro al que pertenece el ciudadano
   *    p_codusu    - Cdigo de usuario que le ha asignado el centro
   *    p_telefdom  - Telfono de domicilio
   *    p_telefmovil- Telfono mvil
   *    p_correo    - Direccin de correo electrnico
   *    p_fechaalt  - Fecha alta en el centro
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
 PROCEDURE CIUDADANOS_Add(
                          p_idpersona          IN     CIUDADANOS.IDPERSONA%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndPersona    EXCEPTION;
      er_notfndCentro     EXCEPTION;
      er_duplicado        EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CIUDADANOS_Add';    
      v_log :=    'p_idpersona ->' || p_idpersona                
                ||', p_idcentro ->' || p_idcentro
                ||', p_telefdom ->' || p_telefdom
                ||', p_telefmovil ->' || p_telefmovil
                ||', p_correo  ->' || p_correo
                ||', p_fechaalt ->' || p_fechaalt;
      p_RSP := ' ';       
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idpersona IS NULL
         OR p_idcentro IS NULL        
         OR p_fechaalt IS NULL
         THEN
          RAISE er_null;
      END IF;
      -- Verificar si exite persona
      IF UTILIDADES.PERSONAS_Found(p_idpersona)='N' THEN
            RAISE er_notfndPersona;
      END IF;
     -- Verificar si exite centro de salud
      IF UTILIDADES.CENTROS_SALUD_Found(p_idcentro)='N' THEN
            RAISE er_notfndCentro;
      END IF; 
       -- Verificar duplicado
      IF UTILIDADES.CIUDADANOS_Found(p_idpersona, p_idcentro)='S' THEN
            RAISE er_duplicado;
      END IF; 
      -- Aade registro
      INSERT INTO CIUDADANOS(IDPERSONA, IDCENTRO, CODUSU, TELEFDOM
                            ,TELEFMOVIL, CORREO, FECHAALT)
            VALUES (p_idpersona, p_idcentro, p_codusu, p_telefdom
                   ,p_telefmovil, p_correo, p_fechaalt);
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndPersona THEN
         v_err_num := 4;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_duplicado THEN
         v_err_num := 3;                  
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;         
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_notfndCentro THEN
         v_err_num := 5;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP); 
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CIUDADANOS_Add;     
   /* ***************************************************************************
   *  Descripcin: Realiza el alta de un ciudadano desde los datos 
   *  de una persona:
   *                 1 da de alta la persona. 
   *                 2 da de alta el ciudadano.
   *  Parametros entrada (datos a insertar): 
   *    p_ide       - N de indentificacin de persona
   *    p_nombre    - Nombre de persona
   *    p_apellido1 - Primer apellido
   *    p_apellido2 - Segundo apellido
   *    p_fechanac  - Fecha de nacimiento 
   *    p_codpais   - Pais de nacimiento
   *    p_sexo      - Sexo (M = Masculino, F = Fememnino)
   *    p_idcentro  - Identificacin BD de centro al que pertenece el ciudadano
   *    p_codusu    - Cdigo de usuario que le ha asignado el centro
   *    p_telefdom  - Telfono de domicilio
   *    p_telefmovil- Telfono mvil
   *    p_correo    - Direccin de correo electrnico
   *    p_fechaalt  - Fecha alta en el centro
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
   PROCEDURE CIUDADANOS_Add(
                          p_ide                IN     PERSONAS.IDE%TYPE
                         ,p_nombre             IN     PERSONAS.NOMBRE%TYPE
                         ,p_apellido1          IN     PERSONAS.APELLIDO1%TYPE
                         ,p_apellido2          IN     PERSONAS.APELLIDO2%TYPE
                         ,p_fechanac           IN     PERSONAS.FECHANAC%TYPE
                         ,p_codpais            IN     PERSONAS.CODPAIS%TYPE
                         ,p_sexo               IN     PERSONAS.SEXO%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      v_idPersona        PERSONAS.ID%TYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_Persona       EXCEPTION;
      er_Ciudadano     EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CIUDADANOS_Add';    
      v_log := 'p_ide ->' || p_ide                
                ||', p_nombre ->' || p_nombre
                ||', p_apellido1 ->' || p_apellido1
                ||', p_apellido2 ->' || p_apellido2
                ||', p_fechanac  ->' || p_fechanac
                ||', p_codpais ->' || p_codpais
                ||', p_sexo ->' ||p_sexo
                ||', p_idcentro ->' || p_idcentro
                ||', p_telefdom ->' || p_telefdom
                ||', p_telefmovil ->' || p_telefmovil
                ||', p_correo  ->' || p_correo
                ||', p_fechaalt ->' || p_fechaalt;
      p_RSP := ' ';
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
      -- 1 Aade persona
      ACT_PERSONA.PERSONAS_Add(p_ide, p_nombre , p_apellido1, p_apellido2
                              ,p_fechanac, p_codpais, p_sexo
                              ,v_idPersona, p_RSP);
      
      IF NOT p_RSP = 'OK' THEN
          RAISE er_Persona;     
      END IF;
      -- 2 Aade ciudadano
      p_RSP := ' ';
      ACT_SALUD.CIUDADANOS_Add(v_idPersona, p_idcentro, p_codusu, p_telefdom
                               , p_telefmovil, p_correo, p_fechaalt, p_RSP);                   
    
      IF NOT p_RSP = 'OK' THEN
          RAISE er_Ciudadano;     
      END IF;
      
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
      
   EXCEPTION
      WHEN er_Persona THEN         
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S','PERSONA - ' || p_RSP);
       WHEN er_Ciudadano THEN        
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S','CIUDADANO - ' || p_RSP); 
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CIUDADANOS_Add;   

  /* ***************************************************************************
   *  Descripcin: Realiza la actualizacin de datos de un ciudadano en la BD
   *               (busca por Id de ciudadano)
   *  Parametros entrada:
   *    p_id        - Identificador de ciudadano a modificar
   *    p_codusu    - Cdigo de usuario que le ha asignado el centro
   *    p_telefdom  - Telfono de domicilio
   *    p_telefmovil- Telfono mvil
   *    p_correo    - Direccin de correo electrnico
   *    p_fechaalt  - Fecha alta en el centro
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
   PROCEDURE CIUDADANOS_Update(
                          p_id                 IN     CIUDADANOS.ID%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
    IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndCiudadano  EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CIUDADANOS_Update';    
      v_log :=  'p_id ->' || p_id
                ||', p_codusu ->' || p_codusu
                ||', p_telefdom ->' || p_telefdom
                ||', p_telefmovil ->' || p_telefmovil
                ||', p_correo  ->' || p_correo
                ||', p_fechaalt ->' || p_fechaalt;
      p_RSP := ' ';
                
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF  p_id IS NULL        
       OR p_fechaalt IS NULL
         THEN
          RAISE er_null;
      END IF;
       -- Verificar si existe ciudadano
      IF UTILIDADES.CIUDADANOS_Found(p_id)='N' THEN
         RAISE er_notfndCiudadano;
      END IF;
      -- Actualiza registro indicado en p_id
         UPDATE CIUDADANOS
             SET CODUSU = p_codusu,
                 TELEFDOM = p_telefdom,
                 TELEFMOVIL = p_telefmovil,
                 CORREO = p_correo,
                 FECHAALT = p_fechaalt
            WHERE ID = p_id;
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndCiudadano THEN
         v_err_num := 6;                  
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;         
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CIUDADANOS_Update;   
  /* ***************************************************************************
   *  Descripcin:  Realiza el actualizacin de datos de un ciudadano en la BD
   *                (busca por con Id de persona y centro de salud)
   *  Parametros entrada: 
   *    p_idpersona - Identificacin BD de persona 
   *    p_idcentro  - Identificacin BD de centro al que pertenece el ciudadano
   *    p_codusu    - Cdigo de usuario que le ha asignado el centro
   *    p_telefdom  - Telfono de domicilio
   *    p_telefmovil- Telfono mvil
   *    p_correo    - Direccin de correo electrnico
   *    p_fechaalt  - Fecha alta en el centro
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
 PROCEDURE CIUDADANOS_Update(
                          p_idpersona          IN     CIUDADANOS.IDPERSONA%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_codusu             IN     CIUDADANOS.CODUSU%TYPE
                         ,p_telefdom           IN     CIUDADANOS.TELEFDOM%TYPE
                         ,p_telefmovil         IN     CIUDADANOS.TELEFMOVIL%TYPE
                         ,p_correo             IN     CIUDADANOS.CORREO%TYPE
                         ,p_fechaalt           IN     CIUDADANOS.FECHAALT%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg           VARCHAR2 (256);
      v_err_num             NUMBER (10);
      v_id          CIUDADANOS.ID%TYPE;
 
    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndPersona    EXCEPTION;
      er_notfndCentro     EXCEPTION;
      er_notfndCiudadano  EXCEPTION;
      er_Ciudadano        EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CIUDADANOS_Update';    
      v_log :=    'p_idpersona ->' || p_idpersona                
                ||', p_idcentro ->' || p_idcentro
                ||', p_telefdom ->' || p_telefdom
                ||', p_telefmovil ->' || p_telefmovil
                ||', p_correo  ->' || p_correo
                ||', p_fechaalt ->' || p_fechaalt;
      p_RSP := ' ';
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idpersona IS NULL
         OR p_idcentro IS NULL        
         OR p_fechaalt IS NULL
         THEN
          RAISE er_null;
      END IF;
      -- Verificar si exite persona
      IF UTILIDADES.PERSONAS_Found(p_idpersona)='N' THEN
            RAISE er_notfndPersona;
      END IF;
     -- Verificar si exite centro de salud
      IF UTILIDADES.CENTROS_SALUD_Found(p_idcentro)='N' THEN
            RAISE er_notfndCentro;
      END IF; 
       -- Obtiene identificacin de ciudadano
      v_id := UTILIDADES.CIUDADANOS_GetID(p_idpersona, p_idcentro);  
      
      if v_id IS NULL THEN
           RAISE er_notfndCiudadano;
      END IF;
        p_RSP := ' ';
      -- Modifica ciudadano
      CIUDADANOS_Update(v_id, p_codusu, p_telefdom, p_telefmovil
                       ,p_correo, p_fechaalt,p_RSP);
        
       IF NOT p_RSP = 'OK' THEN
          RAISE er_Ciudadano;     
       END IF;      
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos        
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndPersona THEN
         v_err_num := 4;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_notfndCiudadano THEN
         v_err_num := 6;                  
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;         
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_notfndCentro THEN
         v_err_num := 5;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP); 
        WHEN er_Ciudadano THEN        
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S','CIUDADANO - ' || p_RSP); 
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CIUDADANOS_Update;      
   /* ***************************************************************************
   *  Descripcin: Marca como eliminado el registro de un ciudadano en la BD
   *               (busca por Id de ciudadano)
   *  Parametros entrada: 
   *    p_id        - Identificador de ciudadano a modificar
   *    p_fechabaj  - Fecha de baja de registro
   *    p_idmotbaj  - Identificador de motivo de baja
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
    PROCEDURE CIUDADANOS_Delete(
                          p_id                 IN     CIUDADANOS.ID%TYPE
                         ,p_fechabaj           IN     CIUDADANOS.FECHABAJ%TYPE
                         ,p_idmotbaj           IN     CIUDADANOS.IDMOTBAJ%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
    IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndCiudadano  EXCEPTION;  
      er_notfndMotBaja    EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CIUDADANOS_Delete';    
      v_log :=  'p_id ->' || p_id
                ||', p_fechabaj ->' || p_fechabaj
                ||', p_idmotbaj ->' || p_idmotbaj;
      p_RSP := ' ';
    
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF  p_id IS NULL        
         OR p_fechabaj IS NULL
         OR p_idmotbaj IS NULL
         THEN
          RAISE er_null;
      END IF;
      -- Verificar si existe ciudadano
      IF UTILIDADES.CIUDADANOS_Found(p_id)='N' THEN
         RAISE er_notfndCiudadano;
      END IF;
      -- Verificar si existe el motivo de baja
      IF UTILIDADES.MOTIVOS_BAJA_Found(p_idmotbaj)='N' THEN
         RAISE er_notfndMotBaja;
      END IF;
      -- Actualiza registro indicado en p_id
         UPDATE CIUDADANOS
             SET FECHABAJ = p_fechabaj,
                 IDMOTBAJ = p_idmotbaj
            WHERE ID = p_id;
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndCiudadano THEN
         v_err_num := 6;                  
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;         
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndMotBaja THEN
         v_err_num := 7;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
     WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CIUDADANOS_Delete;   
  /* ***************************************************************************
   *  Descripcin:  Marca como eliminado el registro de un ciudadano en la BD
   *                (busca por con Id de persona y centro de salud)
   *  Parametros entrada: 
   *    p_idpersona - Identificacin BD de persona 
   *    p_idcentro  - Identificacin BD de centro al que pertenece el ciudadano
   *    p_fechabaj  - Fecha de baja de registro
   *    p_idmotbaj  - Identificador de motivo de baja
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
  PROCEDURE CIUDADANOS_Delete(
                          p_idpersona          IN     CIUDADANOS.IDPERSONA%TYPE
                         ,p_idcentro           IN     CIUDADANOS.IDCENTRO%TYPE
                         ,p_fechabaj           IN     CIUDADANOS.FECHABAJ%TYPE
                         ,p_idmotbaj           IN     CIUDADANOS.IDMOTBAJ%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
  IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg           VARCHAR2 (256);
      v_err_num             NUMBER (10);
      v_id          CIUDADANOS.ID%TYPE;
 
    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndPersona    EXCEPTION;
      er_notfndCentro     EXCEPTION;
      er_notfndCiudadano  EXCEPTION;
      er_notfndMotBaja    EXCEPTION;
      er_Ciudadano        EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CIUDADANOS_Delete';    
      v_log :=    'p_idpersona ->' || p_idpersona                
                ||', p_idcentro ->' || p_idcentro
                ||', p_fechabaj ->' || p_fechabaj
                ||', p_idmotbaj ->' || p_idmotbaj;
      p_RSP := ' ';
            
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idpersona IS NULL
         OR p_idcentro IS NULL        
         OR p_fechabaj IS NULL
         OR p_idmotbaj IS NULL
         THEN
          RAISE er_null;
      END IF;
      -- Verificar si exite persona
      IF UTILIDADES.PERSONAS_Found(p_idpersona)='N' THEN
            RAISE er_notfndPersona;
      END IF;
     -- Verificar si exite centro de salud
      IF UTILIDADES.CENTROS_SALUD_Found(p_idcentro)='N' THEN
            RAISE er_notfndCentro;
      END IF; 
      -- Verificar si existe el motivo de baja
      IF UTILIDADES.MOTIVOS_BAJA_Found(p_idmotbaj)='N' THEN
         RAISE er_notfndMotBaja;
      END IF;
       -- Obtiene identificacin de ciudadano
      v_id := UTILIDADES.CIUDADANOS_GetID(p_idpersona, p_idcentro);  
      
      if v_id IS NULL THEN
           RAISE er_notfndCiudadano;
      END IF;
        p_RSP := ' ';
      -- Marca ciudadano como eliminado 
      CIUDADANOS_Delete(v_id, p_fechabaj, p_idmotbaj, p_RSP);
        
       IF NOT p_RSP = 'OK' THEN
          RAISE er_Ciudadano;     
       END IF;      
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos        
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndPersona THEN
         v_err_num := 4;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_notfndCiudadano THEN
         v_err_num := 6;                  
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;         
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_notfndMotBaja THEN
         v_err_num := 7;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_notfndCentro THEN
         v_err_num := 5;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP); 
        WHEN er_Ciudadano THEN        
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S','CIUDADANO - ' || p_RSP); 
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CIUDADANOS_Delete;  
   
   /* ***************************************************************************
   *  Descripcin: Realiza el alta de un centro de salud en la BD
   *  Parametros entrada (datos a insertar): 
   *    p_codpais    - Codigo de pais al que pertenece el centro de salud
   *    p_codcentro  - Codigo de centro de salud proporcionado por el centro
   *    p_nombre     - Nombre del centro de salud
   *    p_telefono   - Telfono de centro de salud
   *    p_correo     - Direccin de correo electrnico
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
  PROCEDURE CENTROS_SALUD_Add(
                          p_codpais            IN     CENTROS_SALUD.CODPAIS%TYPE
                         ,p_codcentro          IN     CENTROS_SALUD.CODCENTRO%TYPE
                         ,p_nombre             IN     CENTROS_SALUD.NOMBRE%TYPE
                         ,p_telefono           IN     CENTROS_SALUD.TELEFONO%TYPE
                         ,p_correo             IN     CENTROS_SALUD.CORREO%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
  IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_duplicado        EXCEPTION;
      er_notfndPais       EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CENTROS_SALUD_Add';    
      v_log :=    'p_codpais ->' || p_codpais                
                ||', p_codcentro ->' || p_codcentro
                ||', p_nombre ->' || p_nombre
                ||', p_telefono ->' || p_telefono
                ||', p_correo  ->' || p_correo;
      p_RSP := ' ';
            
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_codpais IS NULL
         OR p_codcentro IS NULL        
         THEN
          RAISE er_null;
      END IF;
      -- Verifica si existe pais inidcado      
      IF UTILIDADES.PAISES_Found(p_codpais)='N' THEN
            RAISE er_notfndPais;
      END IF;       
       -- Verificar duplicado
      IF UTILIDADES.CENTROS_SALUD_Found(p_codpais, p_codcentro)='S' THEN
            RAISE er_duplicado;
      END IF; 
      -- Aade registro
      INSERT INTO CENTROS_SALUD(CODPAIS, CODCENTRO, NOMBRE, TELEFONO,CORREO)
            VALUES (p_codpais, p_codcentro, p_nombre, p_telefono, p_correo);
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndPais THEN
         v_err_num := 2;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
       WHEN er_duplicado THEN
         v_err_num := 3;                  
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;         
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CENTROS_SALUD_Add;     
    /* ***************************************************************************
   *  Descripcin: Realiza la actualizacin de datos de un centro en la BD
   *  Parametros entrada: 
   *    p_id         - Identificacin de centro en la BD
   *    p_nombre     - Nombre del centro de salud
   *    p_telefono   - Telfono de centro de salud
   *    p_correo     - Direccin de correo electrnico
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
  PROCEDURE CENTROS_SALUD_Update(
                          p_id                 IN     CENTROS_SALUD.ID%TYPE
                         ,p_nombre             IN     CENTROS_SALUD.NOMBRE%TYPE
                         ,p_telefono           IN     CENTROS_SALUD.TELEFONO%TYPE
                         ,p_correo             IN     CENTROS_SALUD.CORREO%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
                         
  IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndCentro     EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CENTROS_SALUD_Update';    
      v_log :=   ' p_nombre ->' || p_nombre
                ||', p_telefono ->' || p_telefono
                ||', p_correo  ->' || p_correo;
      p_RSP := ' ';         
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_id IS NULL      
         THEN
          RAISE er_null;
      END IF;
      -- Verificar si exite centro de salud
      IF UTILIDADES.CENTROS_SALUD_Found(p_id)='N' THEN
            RAISE er_notfndCentro;
      END IF;      
     
      -- Modifica registro
      UPDATE CENTROS_SALUD
        SET NOMBRE = p_nombre,
            TELEFONO = p_telefono,
            CORREO = p_correo
        WHERE ID = p_id;

      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndCentro THEN
         v_err_num := 5;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);    
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CENTROS_SALUD_Update;  
    /* ***************************************************************************
   *  Descripcin: Marca como eleminado un registro de los centros de salud
   *  Parametros entrada: 
   *    p_id         - Identificacin de centro en la BD
   *    p_fechabaj   - Fecja de baja
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin procedimiento    
   ****************************************************************************/
  PROCEDURE CENTROS_SALUD_Delete(
                          p_id                 IN     CENTROS_SALUD.ID%TYPE
                         ,p_fechabaj           IN     CENTROS_SALUD.FECHABAJ%TYPE
                         ,p_RSP                OUT    VARCHAR2 )
  IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);      
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndCentro     EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'CENTROS_SALUD_Delete';    
      v_log :=   ' p_id ->' || p_id
               ||', p_fechabaj ->' || p_fechabaj;
      p_RSP := ' ';   
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF  p_id IS NULL   
       OR p_fechabaj IS NULL
         THEN
          RAISE er_null;
      END IF;
      
      -- Verificar si exite centro de salud
      IF UTILIDADES.CENTROS_SALUD_Found(p_id)='N' THEN
            RAISE er_notfndCentro;
      END IF;
     
      -- Marca el registro como borrado
      UPDATE CENTROS_SALUD
        SET FECHABAJ = p_fechabaj
        WHERE ID = p_id;

      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndCentro THEN
         v_err_num := 5;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);    
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END CENTROS_SALUD_Delete; 
/******************************************************************************
 *  Descripcin: Actualiza el regisro actividad diaria de un ciudadano en la BD:
 *  - Si no hay registro de ese dia, crea uno nuevo con los datos proporcionados
 *  - Si hay registro de ese dia, lo actualiza con los datos proporcionados
 *  Parametros entrada (datos a insertar): 
 *    p_idciu    - Identificacin BD de ciudadano
 *    p_fecha    - Da al que pertenecen los datos que se registran (dd/mm/yyyy)
 *    p_pasos    - Nmero de pasos realizados durante este Da
 *    p_calorias - Nmero de calorias gastadas durante este Da
 *    p_hpocact  - Nmero de horas que la persona ha permanecido inactiva
 *  Parametro de salida: p_RSP
 *      Contiene:
 *                'OK' - > si la ejecucin ha sido correcta
 *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
 *
 *  Autor            Fecha creacin/modificacin
 *---------------------------------------------------------------------------
 * Mari Cruz         01-11-2014  Creacin procedimiento    
 ****************************************************************************/
 PROCEDURE ACT_DIARIA_Act(
                          p_idciu      IN     ACT_DIARIA.IDCIU%TYPE
                         ,p_fecha      IN     ACT_DIARIA.FECHA%TYPE
                         ,p_pasos      IN     ACT_DIARIA.PASOS%TYPE
                         ,p_calorias   IN     ACT_DIARIA.CALORIAS%TYPE
                         ,p_hpocact    IN     ACT_DIARIA.HPOCACT%TYPE
                         ,p_RSP        OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro              VARCHAR2 (50);
      v_log                VARCHAR2 (500);  
      v_datreg  EST_ANU_PAI_SALUD%ROWTYPE;
      v_adrow          ACT_DIARIA%ROWTYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndCiudadano  EXCEPTION;  
      er_alimEstNotOK     EXCEPTION;
      er_valFueRango      EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'ACT_DIARIA_Act';    
      v_log :=    'p_idciu ->' || p_idciu                
                ||', p_fecha ->' || p_fecha
                ||', p_pasos ->' || p_pasos
                ||', p_calorias ->' || p_calorias
                ||', p_hpocact  ->' || p_hpocact;                
      p_RSP := ' ';        
     
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idciu IS NULL
         OR p_fecha IS NULL        
         OR p_pasos IS NULL
         OR p_calorias IS NULL
         OR p_hpocact IS NULL
         THEN
          RAISE er_null;
      END IF;
      -- Verificar rango de valores
      IF p_pasos < 0 THEN
          RAISE er_valFueRango;
      END IF;      
      IF p_calorias < 0 THEN
          RAISE er_valFueRango;
      END IF;      
      IF p_hpocact < 0 THEN
          RAISE er_valFueRango;
      END IF;      
       -- Verificar si existe ciudadano
      IF UTILIDADES.CIUDADANOS_Found(p_idciu)='N' THEN
            RAISE er_notfndCiudadano;
      END IF; 
      
      v_adrow := UTILIDADES.ACT_DIARIA_GetRow(p_idciu,p_fecha);
      
      IF v_adrow.idciu IS NULL THEN
         -- ********************** Inserta datos  ********************
         INSERT INTO ACT_DIARIA(IDCIU, FECHA, PASOS, CALORIAS, HPOCACT)
            VALUES (p_idciu, p_fecha, p_pasos, p_calorias, p_hpocact); 
            
        --  ************     Alimenta mdulo estadtica    **************  
        -- Para ao
        v_datreg.ANIO:=TO_CHAR(p_fecha,'yyyy');
        -- Para ao y pais
        v_datreg.CODPAIS:=UTILIDADES.CIUDADANOS_GetPais(p_idciu);
        -- Para ciudadanos con actividad diaria
        v_datreg.CIUSCONA:=1;    
        -- Para Calorias de los ciudadanos
        v_datreg.CALSCIUS:= p_calorias;
        -- Para Pasos de los Ciudadanos
        v_datreg.PASCIUS:= p_pasos;
        -- Para Horas poca actividad de los Ciudadanos
        v_datreg.HPACIUS:= p_hpocact;
        -------- Actualiza datos ao -------------
        ESTADISTICA.ESTANISALUD_Acu(v_datreg,p_RSP);    
        IF p_RSP <> 'OK' THEN
           RAISE er_alimEstNotOK;
        END IF;
        -----Actualiza datos ao y pais -----------
        ESTADISTICA.ESTANIPAISALUD_Acu(v_datreg,p_RSP); 
        IF p_RSP <> 'OK' THEN
           RAISE er_alimEstNotOK;
        END IF;
        --  ***********************************************************
      ELSE
        -- **********************   Actualiza datos  *******************
         UPDATE ACT_DIARIA
          SET PASOS = p_pasos,
              CALORIAS = p_calorias,
              HPOCACT = p_hpocact
          WHERE IDCIU = p_idciu
           AND  FECHA = p_fecha;

         --  ************     Alimenta mdulo estadtica    **************  
         -- Para ao
         v_datreg.ANIO:=TO_CHAR(v_adrow.fecha,'yyyy');
         -- Para ao y pais
         v_datreg.CODPAIS:=UTILIDADES.CIUDADANOS_GetPais(v_adrow.IDCIU);
         -- Para ciudadanos con actividad diaria
         v_datreg.CIUSCONA:= NULL;    
         -- Para Calorias de los ciudadanos
         v_datreg.CALSCIUS:= p_calorias -(v_adrow.CALORIAS);
         -- Para Pasos de los Ciudadanos
         v_datreg.PASCIUS:= p_pasos -(v_adrow.PASOS);
         -- Para Horas poca actividad de los Ciudadanos
         v_datreg.HPACIUS:= p_hpocact -(v_adrow.HPOCACT);
         -------- Actualiza datos ao -------------
         ESTADISTICA.ESTANISALUD_Acu(v_datreg,p_RSP); 
         IF p_RSP <> 'OK' THEN
            RAISE er_alimEstNotOK;
         END IF;
         -----Actualiza datos ao y pais ----------- 
         ESTADISTICA.ESTANIPAISALUD_Acu(v_datreg,p_RSP); 
        --  ***********************************************************  
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
      END IF;   
      
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndCiudadano THEN
         v_err_num := 6;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);  
      WHEN er_valFueRango THEN
         v_err_num := 15;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);  
      WHEN er_alimEstNotOK THEN
         v_err_num := 10;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);     
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
END ACT_DIARIA_Act; 

/******************************************************************************
 *  Descripcin: Actualiza la historia anual de un ciudadano en la BD:
 *  - Si no hay registro de ese ao, crea uno nuevo con los datos proporcionados
 *  - Si hay registro de ese ao, lo actualiza con los datos proporcionados
 *  Parametros entrada (datos a insertar): 
 *    p_idciu       - Identificacin BD de ciudadano
 *    p_anio        - Ao historia (9999)
 *    p_visitasmed  - Nmero visitas que ha realizado al mdico
 *    p_enflevs     - Enfermedades leves que ha padecido durante el ao
 *  Parametro de salida: 
 *   p_id  -  Devuelve identificador de historia salud
 *   p_RSP -  Devuelve:
 *                'OK' - > si la ejecucin ha sido correcta
 *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
 *
 *  Autor            Fecha creacin/modificacin
 *---------------------------------------------------------------------------
 * Mari Cruz         10-11-2014  Creacin procedimiento    
 ****************************************************************************/
 PROCEDURE HIS_SALUD_Act(
                          p_idciu      IN     HIS_SALUD.IDCIU%TYPE
                         ,p_anio       IN     HIS_SALUD.ANIO%TYPE
                         ,p_visitasmed IN     HIS_SALUD.VISITASMED%TYPE
                         ,p_enflevs    IN     HIS_SALUD.ENFLEVS%TYPE
                         ,p_id         OUT    HIS_SALUD.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);
      v_id                HIS_SALUD.ID%TYPE;
      v_hsrow             HIS_SALUD%ROWTYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndCiudadano  EXCEPTION;  
      er_alimEstNotOK     EXCEPTION;
      er_valFueRango      EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'HIS_SALUD_Act';    
      v_log :=    'p_idciu ->' || p_idciu                
                ||', p_anio ->' || p_anio
                ||', p_visitasmed ->' || p_visitasmed
                ||', p_enflevs ->' || p_enflevs;              
      p_RSP := ' ';      
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
      p_id := NULL;
      --Verificar que los campos obligatorios no estn a null
      IF p_idciu IS NULL
         OR p_anio IS NULL        
         OR p_visitasmed IS NULL
         OR p_enflevs IS NULL
         THEN
          RAISE er_null;
      END IF;
      -- Verificar rango de valores
      IF p_visitasmed < 0 THEN
          RAISE er_valFueRango;
      END IF;
      
      IF p_enflevs < 0 THEN
          RAISE er_valFueRango;
      END IF;
      
       -- Verificar si existe ciudadano
      IF UTILIDADES.CIUDADANOS_Found(p_idciu)='N' THEN
            RAISE er_notfndCiudadano;
      END IF; 
      -- Si existe recuperamos fila correspondiente a historia 
      v_hsrow := UTILIDADES.HIS_SALUD_GetRow(p_idciu, p_anio);
  
      IF v_hsrow.id IS NULL THEN 
         -- Generamos identificador de historia desde secuencuencia
         SELECT BDSALUD.SE_HIS_SALUD.nextval INTO p_id FROM DUAL; 
         
         -- ********************** Inserta datos  ********************
         INSERT INTO HIS_SALUD(ID, IDCIU, ANIO, VISITASMED, ENFLEVS)
            VALUES (p_id, p_idciu, p_anio, p_visitasmed, p_enflevs); 
            
        --  ************     Alimenta mdulo estadtica    **************
        -- Para Enfermedades leves de los ciudadanos del ao
         ESTADISTICA.ESTSALUD_COLUMN_Acu(p_anio
                          ,'ELEVCIUS'
                          ,p_enflevs
                          ,p_RSP);
        IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
        END IF;
        -- Para Enfermedades leves de los ciudadanos de ao y pais
        ESTADISTICA.ESTSALUD_COLUMN_Acu(p_anio
                          ,UTILIDADES.CIUDADANOS_GetPais(p_idciu)
                          ,'ELEVCIUS'
                          ,p_enflevs
                          ,p_RSP);
        IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
        END IF;
        --  ***********************************************************
      ELSE
        p_id := v_hsrow.id;
        -- **********************   Actualiza datos  *******************
         UPDATE HIS_SALUD
          SET VISITASMED = p_visitasmed
             ,ENFLEVS = p_enflevs
          WHERE IDCIU = p_idciu
           AND  ANIO = p_anio;
        --  ************     Alimenta mdulo estadtica    **************
         -------------------- Ao ------------------
         -- Para Enfermedades leves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(p_anio
                             ,'ELEVCIUS'
                             ,(p_enflevs - (v_hsrow.ENFLEVS))
                             ,p_RSP);
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
         ----------------- Ao y pais ---------------
         -- Para Enfermedades leves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(p_anio
                          ,UTILIDADES.CIUDADANOS_GetPais(p_idciu)
                          ,'ELEVCIUS'
                          ,(p_enflevs - (v_hsrow.ENFLEVS))
                          ,p_RSP);   
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
         --  ***********************************************************  
      END IF;      
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      v_log := v_log || ', p_id ->' || p_id;  
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndCiudadano THEN
         v_err_num := 6;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);  
      WHEN er_valFueRango THEN
         v_err_num := 15;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);  
      WHEN er_alimEstNotOK THEN
         v_err_num := 10;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);     
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
END HIS_SALUD_Act;   

/******************************************************************************
 *  Descripcin: Asigna nueva enfermedad a historia salud.
 *  Parametros entrada (datos a insertar): 
 *    p_idhis       - Identificacin BD de historia salud
 *    p_idenf       - Identificacin en la BD de enfermedad
 *  Parametro de salida: p_RSP
 *      Contiene:
 *                'OK' - > si la ejecucin ha sido correcta
 *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
 *
 *  Autor            Fecha creacin/modificacin
 *---------------------------------------------------------------------------
 * Mari Cruz         10-11-2014  Creacin procedimiento    
 ****************************************************************************/
 PROCEDURE HISSALUD_ENF_Add(
                          p_idhis      IN     HIS_SALUD.ID%TYPE
                         ,p_idenf      IN     ENFERMEDADES.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro             VARCHAR2 (50);
      v_log               VARCHAR2 (500);  
      v_idciu       HIS_SALUD.IDCIU%TYPE;
      v_anio         HIS_SALUD.ANIO%TYPE;
      v_colest  ENFERMEDADES.COLEST%TYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndEnfermedad EXCEPTION;
      er_notfndHisSalud   EXCEPTION;
      er_alimEstNotOK     EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'HISSALUD_ENF_Add';    
      v_log :=    'p_idhis ->' || p_idhis                
                ||', p_idenf ->' || p_idenf;              
      p_RSP := ' ';      
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idhis IS NULL
         OR p_idenf IS NULL        
         THEN
          RAISE er_null;
      END IF;
       -- Verificar si existe enfermedad
      IF UTILIDADES.ENFERMEDADES_Found(p_idenf)='N' THEN
            RAISE er_notfndEnfermedad;
      END IF; 
      IF UTILIDADES.HIS_SALUD_Found(p_idhis)='N' THEN
            RAISE er_notfndHisSalud;
      END IF;
      
      IF UTILIDADES.HISSALUD_ENF_Found(p_idhis, p_idenf)='N' THEN
      
          INSERT INTO HISSALUD_ENF(IDHIS, IDENF)
                VALUES (p_idhis, p_idenf); 
      END IF; 
      --  ************     Alimenta mdulo estadtica    **************
         v_anio := UTILIDADES.HIS_SALUD_GetAnio(p_idhis);
         v_idciu := UTILIDADES.HIS_SALUD_GetIdCiu(p_idhis);
         v_colest := UTILIDADES.ENFERMEDADES_GetColEst(p_idenf);
         
          -------------------- Ao ------------------
          -- Para Enfermedades graves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(v_anio
                             ,v_colest
                             ,1
                             ,p_RSP);
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
       
         ----------------- Ao y pais ---------------
         -- Para Enfermedades graves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(v_anio
                          ,UTILIDADES.CIUDADANOS_GetPais(v_idciu)
                          ,v_colest
                          ,1
                          ,p_RSP);   
                          
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
         
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndEnfermedad THEN
         v_err_num := 9;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);     
      WHEN er_notfndHisSalud THEN
         v_err_num := 8;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);     
      WHEN er_alimEstNotOK THEN
         v_err_num := 14;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);       
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
END HISSALUD_ENF_Add;  
  /* ***************************************************************************
   *  Descripcin: Elimina registro de la tabla ACT_DIARIA
   *  Parametros entrada: 
   *    p_idciu         - Identificacin de ciudadano en la BD
   *    p_fecha         - Dia de actividad   
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         20-11-2014  Creacin procedimiento    
   ****************************************************************************/
  PROCEDURE ACT_DIARIA_Delete(
                          p_idciu      IN     ACT_DIARIA.IDCIU%TYPE
                         ,p_fecha      IN     ACT_DIARIA.FECHA%TYPE
                         ,p_RSP        OUT    VARCHAR2 ) 
  IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);
      v_datreg  EST_ANU_PAI_SALUD%ROWTYPE;
      v_adrow          ACT_DIARIA%ROWTYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndActDia     EXCEPTION;
      er_alimEstNotOK     EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'ACT_DIARIA_Delete';    
      v_log :=   ' p_idciu ->' || p_idciu
               ||', p_fecha ->' || p_fecha;
      p_RSP := ' ';       
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idciu IS NULL
       OR p_fecha IS NULL 
         THEN
          RAISE er_null;
      END IF;
      
      v_adrow := UTILIDADES.ACT_DIARIA_GetRow(p_idciu,p_fecha);
      
      IF v_adrow.idciu IS NULL THEN
         RAISE er_notfndActDia;
      END IF;      
      
      -- Elimina registro de la BD
      DELETE FROM ACT_DIARIA
        WHERE IDCIU = p_idciu
          AND FECHA = p_fecha;          
      
       --  ************     Alimenta mdulo estadtica    **************  
         -- Para ao
         v_datreg.ANIO:=TO_CHAR(v_adrow.fecha,'yyyy');
         -- Para ao y pais
         v_datreg.CODPAIS:=UTILIDADES.CIUDADANOS_GetPais(v_adrow.IDCIU);
         -- Para ciudadanos con actividad diaria
         v_datreg.CIUSCONA:= 0;    
         -- Para Calorias de los ciudadanos
         v_datreg.CALSCIUS:= -(v_adrow.CALORIAS);
         -- Para Pasos de los Ciudadanos
         v_datreg.PASCIUS:= -(v_adrow.PASOS);
         -- Para Horas poca actividad de los Ciudadanos
         v_datreg.HPACIUS:= -(v_adrow.HPOCACT);
         -------- Actualiza datos ao -------------
         ESTADISTICA.ESTANISALUD_Acu(v_datreg,p_RSP); 
         IF p_RSP <> 'OK' THEN
            RAISE er_alimEstNotOK;
         END IF;
         -----Actualiza datos ao y pais ----------- 
         ESTADISTICA.ESTANIPAISALUD_Acu(v_datreg,p_RSP); 
         IF p_RSP <> 'OK' THEN
            RAISE er_alimEstNotOK;
         END IF;
        --  ***********************************************************  
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndActDia THEN
         v_err_num := 11;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
     WHEN er_alimEstNotOK THEN
         v_err_num := 10;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END ACT_DIARIA_Delete; 
   
 /* ***************************************************************************
   *  Descripcin: Elimina registro de la tabla HIS_SALUD y sus relacciones
   *  Parametros entrada: 
   *    p_id         - Identificacin historia salud en la BD   
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         20-11-2014  Creacin procedimiento    
   ****************************************************************************/
  PROCEDURE HIS_SALUD_Delete(
                          p_id         IN     HIS_SALUD.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 )
  IS
      -- Declaracin de variables                   
      v_nompro            VARCHAR2 (50);
      v_log               VARCHAR2 (500);
      v_datreg  EST_ANU_PAI_SALUD%ROWTYPE;
      v_hsrow          HIS_SALUD%ROWTYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndHisSalud   EXCEPTION;
      er_alimEstNotOK     EXCEPTION;
      er_eliRelHisEnf     EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'HIS_SALUD_Delete';    
      v_log :=   ' p_id->' || p_id;
      p_RSP := ' ';       
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_id IS NULL THEN
          RAISE er_null;
      END IF;
      
      v_hsrow := UTILIDADES.HIS_SALUD_GetRow(p_id);
      
      IF v_hsrow.ID IS NULL THEN
         RAISE er_notfndHisSalud;
      END IF;      
      
      -- ** Elimina asignaciones relacionadas con historia salud **
      HISSALUD_ENF_Delete(v_hsrow.ID,p_RSP);
      
      IF p_RSP <> 'OK' THEN
         RAISE er_eliRelHisEnf;
      END IF;
      
      -- Elimina registro de la BD
      DELETE FROM HIS_SALUD
        WHERE ID = p_id;          
      
      --  ************     Alimenta mdulo estadtica    **************
         -------------------- Ao ------------------
         -- Para Enfermedades leves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(v_hsrow.ANIO
                             ,'ELEVCIUS'
                             , -(v_hsrow.ENFLEVS)
                             ,p_RSP);
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
         ----------------- Ao y pais ---------------
         -- Para Enfermedades leves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(v_hsrow.ANIO
                          ,UTILIDADES.CIUDADANOS_GetPais(v_hsrow.IDCIU)
                          ,'ELEVCIUS'
                          ,- (v_hsrow.ENFLEVS)
                          ,p_RSP);   
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
         --  ***********************************************************   
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndHisSalud THEN
         v_err_num := 8;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
     WHEN er_alimEstNotOK THEN
         v_err_num := 10;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
     WHEN er_eliRelHisEnf THEN
         v_err_num := 13;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
   END HIS_SALUD_Delete; 
   
/******************************************************************************
 *  Descripcin: Elimina de la BD asignacin historia salud a enfermedad.
 *  Parametros entrada: 
 *    p_idhis       - Identificacin BD de historia salud
 *    p_idenf       - Identificacin en la BD de enfermedad
 *  Parametro de salida: p_RSP
 *      Contiene:
 *                'OK' - > si la ejecucin ha sido correcta
 *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
 *
 *  Autor            Fecha creacin/modificacin
 *---------------------------------------------------------------------------
 * Mari Cruz         10-11-2014  Creacin procedimiento    
 ****************************************************************************/
 PROCEDURE HISSALUD_ENF_Delete(
                          p_idhis      IN     HIS_SALUD.ID%TYPE
                         ,p_idenf      IN     ENFERMEDADES.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro             VARCHAR2 (50);
      v_log               VARCHAR2 (500);  
      v_idciu       HIS_SALUD.IDCIU%TYPE;
      v_anio         HIS_SALUD.ANIO%TYPE;
      v_colest  ENFERMEDADES.COLEST%TYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndEnfermedad EXCEPTION;
      er_notfndHisSalud   EXCEPTION;
      er_notfndRelHisEnf  EXCEPTION;
      er_alimEstNotOK     EXCEPTION;
   BEGIN
    -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'HISSALUD_ENF_Delete';    
      v_log :=    'p_idhis ->' || p_idhis                
                ||', p_idenf ->' || p_idenf;              
      p_RSP := ' ';      
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idhis IS NULL
         OR p_idenf IS NULL        
         THEN
          RAISE er_null;
      END IF;
       -- Verificar si existe enfermedad
      IF UTILIDADES.ENFERMEDADES_Found(p_idenf)='N' THEN
            RAISE er_notfndEnfermedad;
      END IF; 
      IF UTILIDADES.HIS_SALUD_Found(p_idhis)='N' THEN
            RAISE er_notfndHisSalud;
      END IF;
      
      IF UTILIDADES.HISSALUD_ENF_Found(p_idhis, p_idenf)='N' THEN
         RAISE er_notfndRelHisEnf;
      END IF; 
      
      -- Elimina registro de la BD
      DELETE FROM HISSALUD_ENF
        WHERE IDHIS = p_idhis
          AND IDENF = p_idenf;    
          
      --  ************     Alimenta mdulo estadtica    **************
         v_anio := UTILIDADES.HIS_SALUD_GetAnio(p_idhis);
         v_idciu := UTILIDADES.HIS_SALUD_GetIdCiu(p_idhis);
         v_colest := UTILIDADES.ENFERMEDADES_GetColEst(p_idenf);
         
          -------------------- Ao ------------------
          -- Para Enfermedades leves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(v_anio
                             ,v_colest
                             ,(-1)
                             ,p_RSP);
         IF p_RSP <> 'OK' THEN
          RAISE er_alimEstNotOK;
         END IF;
       
         ----------------- Ao y pais ---------------
         -- Para Enfermedades leves de los ciudadanos
         ESTADISTICA.ESTSALUD_COLUMN_Acu(v_anio
                          ,UTILIDADES.CIUDADANOS_GetPais(v_idciu)
                          ,v_colest
                          ,(-1)
                          ,p_RSP);   
                          
         IF p_RSP <> 'OK' THEN
           RAISE er_alimEstNotOK;
         END IF;
         
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndEnfermedad THEN
         v_err_num := 9;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);     
      WHEN er_notfndHisSalud THEN
         v_err_num := 8;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);       
     WHEN er_notfndRelHisEnf THEN
         v_err_num := 12;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);     
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
END HISSALUD_ENF_Delete;  
/******************************************************************************
 *  Descripcin: Elimina de la BD todas asignaciones con enfermedades .
 *               de una historia salud.
 *  Parametros entrada: 
 *    p_idhis       - Identificacin BD de historia salud
 *  Parametro de salida: p_RSP
 *      Contiene:
 *                'OK' - > si la ejecucin ha sido correcta
 *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
 *
 *  Autor            Fecha creacin/modificacin
 *---------------------------------------------------------------------------
 * Mari Cruz         10-11-2014  Creacin procedimiento    
 ****************************************************************************/
 PROCEDURE HISSALUD_ENF_Delete(
                          p_idhis      IN     HIS_SALUD.ID%TYPE
                         ,p_RSP        OUT    VARCHAR2 )
 IS
      -- Declaracin de variables                   
      v_nompro             VARCHAR2 (50);
      v_log               VARCHAR2 (500);  
      v_idciu       HIS_SALUD.IDCIU%TYPE;
      v_anio         HIS_SALUD.ANIO%TYPE;
      v_colest  ENFERMEDADES.COLEST%TYPE;
      
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER (10);
      
      CURSOR c_bus IS
         SELECT IDHIS, IDENF FROM HISSALUD_ENF
          WHERE IDHIS = p_idhis;
          
       v_bus  c_bus%ROWTYPE;

    -- Declaracin de excepciones
      er_null             EXCEPTION;
      er_notfndHisSalud   EXCEPTION;
      er_eliRelHisEnf     EXCEPTION;
   BEGIN
   -- Guardar parametros de entrada inicial en LOGS
      v_nompro := 'HISSALUD_ENF_Delete';    
      v_log :=    'p_idhis ->' || p_idhis;              
      p_RSP := ' ';      
      
      UTILIDADES. LOGS_Add(v_nompro, v_log, 'I','S',p_RSP);
  
      --Verificar que los campos obligatorios no estn a null
      IF p_idhis IS NULL THEN
          RAISE er_null;
      END IF;
       -- Verificar si existe enfermedad
      IF UTILIDADES.HIS_SALUD_Found(p_idhis)='N' THEN
            RAISE er_notfndHisSalud;
      END IF; 
      
      -- Elimina todas las asignaciones a p_idhis de la BD
      FOR v_bus IN c_bus LOOP
        HISSALUD_ENF_Delete(v_bus.IDHIS, v_bus.IDENF,p_RSP);
        IF p_RSP <> 'OK' THEN
          RAISE er_eliRelHisEnf;
         END IF;
      END LOOP;
      -- Si todo es correcto guardamos 'OK' en LOGS Y confirmamos      
      p_RSP := 'OK';
      UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','N',p_RSP);
      COMMIT;
   EXCEPTION
      WHEN er_null THEN
         v_err_num := 1;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
      WHEN er_notfndHisSalud THEN
         v_err_num := 8;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);   
      WHEN er_eliRelHisEnf THEN
         v_err_num := 13;
         v_err_msg := UTILIDADES.ERRORES_GetByID(v_err_num);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - ' || v_err_msg;
         UTILIDADES.LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);  
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_err_msg := SUBSTR (SQLERRM, 1, 100);
         p_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         UTILIDADES. LOGS_Add(v_nompro, v_log, 'F','S',p_RSP);
         DBMS_OUTPUT.PUT_LINE (p_RSP);      
 END HISSALUD_ENF_Delete;  

END ACT_SALUD;
/
