DECLARE
v_RSP               VARCHAR2 (500);
v_id                HIS_SALUD.ID%TYPE;

BEGIN
-- Modifica la historia salud perteneciente a un ciudadano de
-- Finlandia (FI) del ao 2015 (punto 2.1.1. documentacin)
ACT_SALUD.HIS_SALUD_Act(208, 2015, 5, 5,v_id,v_RSP);
ACT_SALUD.HISSALUD_ENF_Add (394, 1,v_RSP);

-- Modifica actividad diaria de un registro del ao 2015 perteneciente a 
-- un ciudadano de Filandia (FI) (punto 2.1.2. documentacin)
ACT_SALUD.ACT_DIARIA_Act(176, to_date('01/01/2015', 'mm/dd/yyyy'), 1500, 1000, 5,v_RSP);

-- Elimina registro de historia salud el registro con ID 8 del que cuelga
-- una enfermedad grave cardiaca asociada (punto 2.1.3. documentacin)
ACT_SALUD.HIS_SALUD_Delete(8,v_RSP);

-- Elimina registro de actividad diaria el registro para el ciudadano con ID 8 
-- y fecha actividad 11/05/2013 (punto 2.1.4. documentacin)
ACT_SALUD.ACT_DIARIA_Delete(8, to_date('11/05/2013', 'mm/dd/yyyy'),v_RSP);
END;
/

