/*---------------------------------------------------------
CON EL USUARIO SYSTEM CREAMOS EL ENTORNO EN LA BASE DE DATOS
PARA EL APLICATIVO Big Data de salut
-----------------------------------------------------------*/

/*---------------------------------------------------------
01 CREACION TABLESPACE TS_BDSALUD 
   EN C:\oraclexe\app\oracle\oradata\XE\TS_BDSALUD.dbf
-----------------------------------------------------------*/ 
CREATE TABLESPACE TS_BDSALUD 
DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\TS_BDSALUD.dbf' 
SIZE 30M
AUTOEXTEND OFF
LOGGING
EXTENT MANAGEMENT LOCAL AUTOALLOCATE;

/*--------------------------------------------------------
02 CREACIO USUARIO QUE GESTIONAR EL APLICATIVO.
   NOM USUARI: BDSALUD
   CONTRASEYA: BDSALUD
----------------------------------------------------------*/
DROP USER BDSALUD   CASCADE;
CREATE USER BDSALUD IDENTIFIED BY BDSALUD 
DEFAULT TABLESPACE "TS_BDSALUD"
TEMPORARY TABLESPACE "TEMP"
ACCOUNT UNLOCK;

GRANT CREATE SESSION,  CREATE DATABASE LINK, CREATE TABLE, CREATE SEQUENCE,
      CREATE PROCEDURE,  CREATE TRIGGER, CREATE VIEW, CONNECT, RESOURCE
TO BDSALUD;

ALTER USER BDSALUD DEFAULT  ROLE ALL;
REVOKE UNLIMITED TABLESPACE FROM BDSALUD;
ALTER USER BDSALUD QUOTA UNLIMITED ON TS_BDSALUD;
