-- Crear vista para consultar CIUDADANOS --
CREATE OR REPLACE FORCE VIEW BDSALUD.W_CONSULTAR_CIUDADANOS 
(ID
,IDPERSONA
,IDCENTRO
,FECHABAJ
,CODUSU
,TELEFDOM
,TELEFMOVIL
,CORREO
,EDAD
,FECHAALT
,IDMOTBAJ
,CODPAIS) AS 
SELECT 
 CI.ID
,CI.IDPERSONA
,CI.IDCENTRO
,CI.FECHABAJ
,CI.CODUSU
,CI.TELEFDOM
,CI.TELEFMOVIL
,CI.CORREO
,UTILIDADES.CIUDADANOS_GetEdad(CI.ID)
,CI.FECHAALT
,CI.IDMOTBAJ
,CS.CODPAIS
FROM CIUDADANOS CI
    ,CENTROS_SALUD CS
WHERE CI.IDCENTRO = CS.ID;

-- Crear vista para consultar ACT_DIARIA --
  CREATE OR REPLACE FORCE VIEW BDSALUD.W_CONSULTAR_ACT_DIARIA 
  (IDCIU
  ,FECHA
  ,PASOS
  ,CALORIAS
  ,HPOCACT
  ,ANIOACT
  ,MESACT) AS 
  SELECT 
  IDCIU
  ,FECHA
  ,PASOS
  ,CALORIAS
  ,HPOCACT
  ,EXTRACT(YEAR FROM FECHA)
  ,EXTRACT(MONTH FROM FECHA)
  FROM ACT_DIARIA;
 
 -- Crear vista para consultar ACT_DIARIA - PERSONA --
  CREATE OR REPLACE FORCE VIEW BDSALUD.W_CONSULTAR_ACT_DIARIA_PERSONA
  (IDCIU
  ,FECHA
  ,PASOS
  ,CALORIAS
  ,HPOCACT
  ,ANIOACT
  ,MESACT
  ,IDPERSONA
  ,IDCENTRO) AS 
  SELECT 
  ACT_DIARIA.IDCIU
  ,ACT_DIARIA.FECHA
  ,ACT_DIARIA.PASOS
  ,ACT_DIARIA.CALORIAS
  ,ACT_DIARIA.HPOCACT
  ,EXTRACT(YEAR FROM FECHA)
  ,EXTRACT(MONTH FROM FECHA)
  ,CIUDADANOS.IDPERSONA
  ,CIUDADANOS.IDCENTRO
  FROM ACT_DIARIA, CIUDADANOS
  WHERE ACT_DIARIA.IDCIU = CIUDADANOS.ID;

 -- Crear vista para consultar HIS_SALUD --
CREATE OR REPLACE FORCE VIEW BDSALUD.W_CONSULTAR_HIS_SALUD 
(ID
,IDCIU
,ANIO
,VISITASMED
,ENFLEVS
,IDENF) AS 
SELECT 
 HS.ID
,HS.IDCIU
,HS.ANIO
,HS.VISITASMED
,HS.ENFLEVS
,HSE.IDENF 
FROM HIS_SALUD HS, HISSALUD_ENF HSE
WHERE HS.ID = HSE.IDHIS(+);
