SET DEFINE OFF
/*--------- Inserta PAISES -----------*/
INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('DE', 'Alemania', 1952.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('AT', 'Austria', 1995.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('BE', 'Blgica', 1952.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('BG', 'Bulgaria', 2007.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('CY', 'Chipre', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('HR', 'Croacia', 2013.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('DK', 'Dinamarca', 1973.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('SK', 'Eslovaquia', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('SI', 'Eslovenia', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('ES', 'Espaa', 1986.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('EE', 'Estonia', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('FI', 'Finlandia', 1995.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('FR', 'Francia', 1952.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('GR', 'Grecia', 1981.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('HU', 'Hungra', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('IE', 'Irlanda', 1973.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('IS', 'Italia', 1952.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('IT', 'Letonia', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('LV', 'Lituania', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('LU', 'Luxemburgo', 1952.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('MT', 'Malta', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('NL', 'Pases Bajos', 1952.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('PL', 'Polonia', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('PT', 'Portugal', 1986.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('UK', 'Reino Unido', 1973.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('CZ', 'Repblica Checa', 2004.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('RO', 'Rumana', 2007.0);

INSERT INTO PAISES (COD, DENOM, ANIOUE) 
VALUES ('SE', 'Suecia', 1995.0);

COMMIT;
/*------- Inserta MOTIVOS BAJA --------*/

INSERT INTO MOTIVOS_BAJA (DENOM) 
VALUES ('(Ninguno)');

INSERT INTO MOTIVOS_BAJA (DENOM) 
VALUES ('Cambio de domicilio');

INSERT INTO MOTIVOS_BAJA (DENOM) 
VALUES ('Baja en el sistema');

INSERT INTO MOTIVOS_BAJA (DENOM) 
VALUES ('Defuncin');

COMMIT;

/*------ 07 Inserta ENFERMEDADES ---------*/

INSERT INTO ENFERMEDADES (DENOM, COLEST) 
VALUES ('Enfermedad cardaca','CIUSECAR');

INSERT INTO ENFERMEDADES (DENOM, COLEST)
VALUES ('Enfermedad cancergena','CIUSECAN');

INSERT INTO ENFERMEDADES (DENOM, COLEST) 
VALUES ('Enfermedad degenerativa','CIUSEDEG');
COMMIT;

/*------ Inserta ERRORES ---------*/
-- 1 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Se han proporcionado valores a Null en datos obligatorios');
-- 2 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Pais no encontrado');
-- 3 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Identificacin duplicada');
-- 4 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Persona no encontrada');
-- 5 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Centro no encontrado');
-- 6 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Ciudadano no encontrado');
-- 7 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Motivo baja no encontrado');
-- 8 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Historia de salud no encontrada');
-- 9 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Enfermedad no encontrada');
-- 10 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Mdulo estadstica no actualizado');
-- 11 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Actividad diaria no encontrada');
-- 12 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Relaccin hitoria salud <-> enfermedad no encontrada');
-- 13 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Relaccin hitoria salud <-> enfermedad con error al eliminar');
-- 14 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Error al eliminar relaccin hitoria salud <-> enfermedad');
-- 15 -
INSERT INTO ERRORES (DESCRIP) 
VALUES ('Parmetro con valor fuera de rango');

COMMIT;