DECLARE
v_RSP               VARCHAR2 (500);
v_id                HIS_SALUD.ID%TYPE;

BEGIN
-- **************   AADIMOS 18 CENTROS DE SALUD Y DAMOS DE BAJA 1 UN CENTRO  (Punto 1.1.1 documentacin) ************** --
ACT_SALUD.CENTROS_SALUD_Add('DE', 'CSDE0001', 'Centro de salud en Alemania', '325259038', 'fic_mail@hotmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('AT', 'CSAT0032', 'Centro de salud en Austria', '325259041', 'fic_mail@hotmail.com ', v_RSP);
ACT_SALUD.CENTROS_SALUD_Add('BE', 'CSBE0001', 'Centro de salud en Blgica', '325259037', 'fic_mail@idiomas.udea.edu.co ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('BG', 'CSBG0001', 'Centro de salud en Bulgaria', NULL, 'fic_mail@idiomas.udea.edu.co ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('CY', 'CSCY0002', 'Centro de salud en Chipre', ' ', 'fic_mail@ idomas.udea.edu.co ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('HR', 'CSHR0001', 'Centro de salud en Croacia', ' ', 'fic_mail@latinmail.com ', v_RSP);
ACT_SALUD.CENTROS_SALUD_Add('DK', 'CSDK0012', 'Centro de salud en Dinamarca', '325259043', 'fic_mail@hotmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('SK', 'CSSK0001', 'Centro de salud en Eslovaquia', ' ', 'fic_mail@latinmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('SI', 'CSSI0001', 'Centro de salud en Eslovenia', ' ', 'fic_mail@yahoo.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('ES', 'CSES0007', 'Centro de salud en Espaa', ' ', 'fic_mail@idiomas.edu.co ', v_RSP);
ACT_SALUD.CENTROS_SALUD_Add('EE', 'CSEE0001', 'Centro de salud en Estonia', '325259041', 'fic_mail@latinmail.com ', v_RSP);
ACT_SALUD.CENTROS_SALUD_Add('FI', 'CSFI0021', 'Centro de salud en Finlandia', '913259012', 'fic_mail@hotmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('FR', 'CSFR0001', 'Centro de salud en Francia', ' ', 'fic_mail@latinmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('GR', 'CSGR0077', 'Centro de salud en Grecia', NULL, 'fic_mail@hotmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('HU', 'CSHU0001', 'Centro de salud en Hungra', NULL, 'fic_mail@latinmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('IE', 'CSIE0001', 'Centro de salud en Irlanda', '971259026', 'fic_mail@hotmail.com ', v_RSP); 
ACT_SALUD.CENTROS_SALUD_Add('IS', 'CSIS0033', 'Centro de salud en Italia', '325259038', 'fic_mail@ubicar.com ', v_RSP);
ACT_SALUD.CENTROS_SALUD_Add('EE', 'CSEE0004', 'Centro de salud en Estonia', '322339038', 'fic_mail2@ubicar.com ', v_RSP);
ACT_SALUD.CENTROS_SALUD_Delete(18,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

-- ******* AADIMOS 6 CIUDADANOS CON DATOS DE PERSONA Y  LOS DAMOS BAJA; EN CIUDADANOS Y PERSONAS (Punto 1.1.2 documentacin)******* --
ACT_SALUD.CIUDADANOS_Add('41225589F', 'MARIA', 'LOPEZ', 'PEREZ', to_date('12/02/1973', 'mm/dd/yyyy'), 'CY', 'M', 5, 'CSCY0000000302', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Delete(1,5,to_date('10/27/2014', 'mm/dd/yyyy'),3,v_RSP);
ACT_PERSONA.PERSONAS_Delete(1,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

ACT_SALUD.CIUDADANOS_Add('T00134356', 'JOHANNA', 'TEMPLIN', 'DESC', to_date('12/03/1979', 'mm/dd/yyyy'), 'ES', 'M',10, 'CSES0000000222', ' ', NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Delete(2, to_date('10/27/2014', 'mm/dd/yyyy'), 3,v_RSP);
ACT_PERSONA.PERSONAS_Delete(2,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

ACT_SALUD.CIUDADANOS_Add('70422445G', 'SIGRID', 'GEIST', 'DESC', to_date('10/29/1979', 'mm/dd/yyyy'), 'ES', 'M', 10, 'CSES0000000224', ' ', NULL, 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Delete(3, to_date('10/27/2014', 'mm/dd/yyyy'), 3,v_RSP);
ACT_PERSONA.PERSONAS_Delete(3,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

ACT_SALUD.CIUDADANOS_Add('T00149997', 'DANIELA', 'HANAMAN', 'DESC', to_date('03/20/1979', 'mm/dd/yyyy'), 'ES', 'M', 10, 'CSES0000000226', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Delete(4, to_date('10/27/2014', 'mm/dd/yyyy'), 3,v_RSP);
ACT_PERSONA.PERSONAS_Delete(4,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

ACT_SALUD.CIUDADANOS_Add('10346006V', 'HERTZ', 'SIHOU', 'MOSH', to_date('03/19/1928', 'mm/dd/yyyy'), 'ES', 'V', 10,'CSES0000000228', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Delete(5, to_date('10/27/2014', 'mm/dd/yyyy'),3,v_RSP);
ACT_PERSONA.PERSONAS_Delete(5,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

ACT_SALUD.CIUDADANOS_Add('00429960K', 'MIRTA', 'GHERMY', 'BEEK', to_date('06/11/1928', 'mm/dd/yyyy'), 'ES', 'V',10, 'CSES0000000230', NULL, NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Delete(6, to_date('10/27/2014', 'mm/dd/yyyy'),3,v_RSP);
ACT_PERSONA.PERSONAS_Delete(6, to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

-- ************** AADIMOS 212 PERSONAS (Punto 1.1.3 documentacin) ************** --
ACT_PERSONA.PERSONAS_Add('T00134356', 'JOHANNA', 'TEMPLIN', 'DESC', to_date('12/03/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('70422445G', 'SIGRID', 'GEIST', 'DESC', to_date('10/29/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00149997', 'DANIELA', 'HANAMAN', 'DESC', to_date('03/20/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('10346006V', 'HERTZ', 'SIHOU', 'MOSH', to_date('03/19/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00429960K', 'MIRTA', 'GHERMY', 'BEEK', to_date('06/11/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00049685', 'CLARA', 'BEEK', 'SAYED', to_date('11/13/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00455777D', 'JURGEN', 'FINK', 'DESC', to_date('03/09/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00466698M', 'BIANCA', 'GERLACH', 'DESC', to_date('11/25/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00109289', 'ABDELHAK', 'MEDIA', 'MEDIA', to_date('04/24/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00501290M', 'THOMAS', 'BAIER', 'DESC', to_date('11/11/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00140638', 'AAJAL', 'AZIZ', 'DESC', to_date('02/12/1937', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00131902', 'AICHA', 'EL', 'GHERMY', to_date('04/02/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00348310K', 'NICHOLAS', 'SMIT', 'BEEK', to_date('08/27/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00496366A', 'MOHAMMED', 'WAHAB', 'DESC', to_date('06/28/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00446073B', 'ABDELILAH', 'ALZAR', NULL, to_date('03/18/1943', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00409334A', 'JORGE ALEJANDRO', 'MARIN', 'DESC', to_date('08/09/1943', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00454084H', 'LUCY ANNE', 'MUNGER', 'DESC', to_date('09/08/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00492391F', 'MOHAMED', 'MERABETY', 'DESC', to_date('03/23/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00411969Q', 'WILL', 'BACLAYEN', 'DOMINGO', to_date('04/07/1946', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00510985V', 'BARTOLOME', 'OLIVER', 'GAYA', to_date('03/11/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00520484V', 'WAFAE', 'HAZAZI', 'DESC', to_date('09/05/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00314180T', 'PAOLO', 'SCIUTO', 'PRODI', to_date('09/25/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00049686', 'INDRA L', 'SAYED', 'HAMED', to_date('10/12/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00415284L', 'ANDREA', NULL, 'VON', to_date('12/04/1957', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00025025R', 'WAHIBA', 'FAZILET', 'GLOCKL', to_date('02/03/1960', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00418433V', 'LUISA', 'QUESADA', 'GALINDO', to_date('06/05/1961', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00348365F', 'EDMUN', 'EHRHARDT', 'HOLS', to_date('03/04/1963', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00421509B', 'ERIKA', 'MARGA', 'GURNAK', to_date('06/08/1963', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00347953D', 'OLIVER', 'LANGE', 'MARCUS', to_date('09/08/1963', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00128005', 'FRITZ', 'JURGEN', 'WIEDERMEIER', to_date('10/31/1963', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('10348309T', 'MARIANNE', 'CHRISTINE', 'DE', to_date('12/20/1969', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('90314182W', 'YOSSIK', 'MISUKE', 'KOZO', to_date('03/13/1973', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00496070Y', 'HOUCINE', 'BELOUALI', 'DESC', to_date('06/23/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41351587W', 'ABDELILAH', 'BENNASER', 'DESC', to_date('08/15/1981', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('99334143E', 'MAXINE', 'CLAIRE', 'SHERRY', to_date('07/14/1982', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00346996V', 'JOSE', 'WALSER', 'GAUS', to_date('07/02/1985', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('33348365F', 'KATRIN', 'HERING', 'DESC', to_date('12/04/1996', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00379377S', 'ISSAH', 'HUSEINI', 'DESC', to_date('04/04/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('555TTTOIP', 'ULRICH', 'MAASS', 'DESC', to_date('04/23/2012', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00011863', 'DOLORES', 'FERRER', 'VERA', to_date('04/10/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41363871G', 'MARIA', 'LORETO', 'BERENGUER', to_date('01/18/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00445356F', 'BENGT', 'TOMAS', 'TIDHOLM', to_date('06/07/1928', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00366182W', 'ERIC', 'RUSTAN', 'BERGMAN', to_date('12/14/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00511334K', 'MARIA', 'ROIG', 'RIBAS', to_date('10/02/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41382335E', 'PEDRO', 'MARTORELL', 'PALOU', to_date('04/28/1969', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00336323V', 'MARIA', 'JESUS', 'BRANCO', to_date('11/01/1974', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41316688V', 'WILFREDO', 'MIRANDA', 'MEJIA', to_date('06/19/1979', 'mm/dd/yyyy'), 'ES', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00125368', 'CECILIA GRANUCCI', 'DESC', 'PALMER', to_date('09/10/1993', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00389263B', 'CARMEN', ' EDELINA', 'BENAVIDES', to_date('10/08/1966', 'mm/dd/yyyy'), 'PT', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41323904B', 'DOLORES', 'TORRES', 'VILELLA', to_date('08/22/1979', 'mm/dd/yyyy'), 'PT', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00370673M', 'GARDENIA', 'PASTOS', 'DUEAS', to_date('10/06/1968', 'mm/dd/yyyy'), 'PT', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('42957433U', 'CLAUDIA', 'VALERIA', 'BATISTA', to_date('10/05/1966', 'mm/dd/yyyy'), 'PT', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43012433H', 'RAMON', 'PALMER', 'TORRES', to_date('05/18/1982', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43054900G', 'PAULA', 'PALMER', 'TORRES', to_date('03/25/1977', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('42942710P', 'MARIA', 'SOTELO', 'URDIALES', to_date('07/25/1976', 'mm/dd/yyyy'), 'PT', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('55262211F', 'VICTOR', 'ALEJANDRO', 'ORMEO', to_date('08/19/1979', 'mm/dd/yyyy'), 'PT', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('42981395F', 'ADRIAN', 'ALBERTO', 'ROJAS', to_date('04/15/1961', 'mm/dd/yyyy'), 'PT', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('45348310K', 'GETRUDIS', 'DUEAS', 'ZUIGA', to_date('07/14/1964', 'mm/dd/yyyy'), 'PT', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41391237T', 'PEDRO', 'PALMER', 'ALEMANY', to_date('12/02/1973', 'mm/dd/yyyy'), 'PT', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00488510J', 'CAROLINA', 'ARABIA', 'DESC', to_date('04/20/1995', 'mm/dd/yyyy'), 'PT', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('70717384C', 'FRANCISCA', 'GARCIA', 'TRIBALDOS', to_date('01/23/1979', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('44362211F', 'LETICIA', 'RUSTAN', 'MINCONE', to_date('03/12/1980', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00369596D', 'MARIA', 'CALDENTEY', 'MESTRE', to_date('12/02/1973', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00369597X', 'JAIME', 'VICH', 'BALLESTER', to_date('11/17/1962', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00358514J', 'JUANA', 'JUAN', 'RIPOLL', to_date('04/18/1990', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('42555897T', 'MARGARITA', 'PALMER', 'GARCIA', to_date('06/13/2007', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('18223010H', 'EVA', 'CATALINA', 'DALMAU', to_date('01/07/1979', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('45371254M', 'LLUC', 'MAIMO', 'DALMAU', to_date('01/03/1979', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('45371256F', 'MARIA', 'MAIMO', 'DALMAU', to_date('04/28/1973', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41295191W', 'MATEO', 'DALMAU', 'FLO', to_date('05/25/1974', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43078112D', 'MARIA', 'JOSE', 'ACEVEDO', to_date('11/21/1973', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('49771379T', 'JAVIER', 'PORTAL', 'ACEVEDO', to_date('04/21/1979', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('37334910E', 'SANDRA', NULL, 'OBRADOR', to_date('07/08/1971', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41339987V', 'JERONIMO', 'ARBOS', 'ORELL', to_date('12/02/1973', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('05283035G', 'CRISTOBAL', 'PORTAL', 'SVENSSON', to_date('06/12/1975', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41098098L', 'CATALINA', 'ESTARELLAS', 'ARBONA', to_date('04/14/1980', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00458779K', 'JAVIER', 'ANTONIO', 'ALVAREZ', to_date('04/28/1963', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('89623982J', 'JUAN', 'BUSTOS', 'MARIN', to_date('06/26/1995', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00029634', 'LAMO', 'QUETA', 'DESC', to_date('08/31/1954', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('25516525A', 'MARTA', NULL, 'BRANCO', to_date('03/14/1967', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00099746', 'MARIA', 'IGLESIAS', 'JARD', to_date('11/16/1991', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41663308G', 'ANA', 'MARIA', 'AGUIL', to_date('05/08/1976', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41500486G', 'MARIA', 'PEDRO', 'CARRERAS', to_date('08/26/1977', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43463600V', 'MARA', 'JOS', 'BAUZ', to_date('07/15/1996', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('50337418D', 'LOURDES', 'BOSCH', 'I', to_date('11/07/1979', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43070463L', 'MARGALIDA', 'CABRER', 'I', to_date('05/17/1979', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('29695569Q', 'ISABEL', 'MARTINEZ', 'BOSQUE', to_date('10/16/1963', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43479648B', 'ROSA', 'MARIA', 'BAUZ', to_date('05/09/1970', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('49610851N', 'JOS', 'RAMN', 'BAUZ', to_date('02/19/1972', 'mm/dd/yyyy'), 'CY', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00013630', 'KATARZYNA', 'DISTERHOFT', 'DESC', to_date('09/28/1997', 'mm/dd/yyyy'), 'DK', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00107543', 'WAHIBA', 'EL', 'HADDOUTI', to_date('07/11/1979', 'mm/dd/yyyy'), 'CZ', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00559924', 'GLORIA', 'VICH', 'LOZANO', to_date('01/07/1979', 'mm/dd/yyyy'), 'IT', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00390178Y', 'GEORGINA', 'ROSE', 'MCMULLEN', to_date('04/25/1979', 'mm/dd/yyyy'), 'PL', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00379343G', 'ROBERT', 'DEYHLE', 'DESC', to_date('08/24/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00497024V', 'MARIA', NULL, 'BRANCO', to_date('11/02/1979', 'mm/dd/yyyy'), 'CZ', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00496267L', 'KATERINA HRISTOVA', 'SANKEVA', 'DESC', to_date('08/14/1979', 'mm/dd/yyyy'), 'CZ', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00441340Q', 'LESBIA', 'CAICEDO', 'ARZAYUS', to_date('07/18/1979', 'mm/dd/yyyy'), 'CZ', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43223982J', 'ANIBAL', 'GONALVES', 'FARIA', to_date('05/27/1979', 'mm/dd/yyyy'), 'CZ', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00454824E', 'ELISAVET', 'KAISARI', 'DESC', to_date('08/18/1979', 'mm/dd/yyyy'), 'IT', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00327074Z', 'MARTA', 'BLECK', 'MARTINS', to_date('08/09/1979', 'mm/dd/yyyy'), 'AT', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00391808A', 'KIRSTY', 'MARIE', 'BRADFORD', to_date('06/01/1979', 'mm/dd/yyyy'), 'PL', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00363054E', 'WAHEED', 'ABU', 'SOLOMON', to_date('07/13/1979', 'mm/dd/yyyy'), 'CZ', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00474584W', 'THEOFANIS', 'MOUZAKIS', 'DESC', to_date('08/20/1979', 'mm/dd/yyyy'), 'IT', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00390177M', 'JOANNA', 'GALSWORTHY', 'DESC', to_date('10/03/1979', 'mm/dd/yyyy'), 'PL', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00382390S', 'WILDER', 'ALFREDO', 'GONZALEZ', to_date('01/02/1979', 'mm/dd/yyyy'), 'RO', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('03479556G', 'BERNADETTE', 'POSSEH', NULL, to_date('06/16/1979', 'mm/dd/yyyy'), 'CZ', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('80334143E', 'WADA', NULL, 'MIKADO', to_date('02/11/1979', 'mm/dd/yyyy'), 'CZ', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00143256', 'WAHEED', 'SHAFI', 'CHAUDHRY', to_date('12/01/1979', 'mm/dd/yyyy'), 'PL', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00496266H', 'GEORGI', 'IVANOV', 'SANKEV', to_date('04/21/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00382885G', 'MARCELO FRANCIS', 'BEJARANO', 'DESC', to_date('07/28/1979', 'mm/dd/yyyy'), 'PL', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00462464A', 'GLORIA', 'LOZANO', NULL, to_date('04/11/1960', 'mm/dd/yyyy'), 'PL', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00012901', 'DANIELA', 'ATANASOVA', 'TASEVA', to_date('07/20/1964', 'mm/dd/yyyy'), 'DE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00079173', 'NICOLAS', 'TORRENS', 'MARTIN', to_date('02/20/1965', 'mm/dd/yyyy'), 'CZ', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00484791C', 'LAUTARO', 'FERNANDEZ', 'DESC', to_date('05/17/1965', 'mm/dd/yyyy'), 'PL', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43103217K', 'YOSHINOSUKE', 'KOZO', 'DESC', to_date('04/28/1968', 'mm/dd/yyyy'), 'PL', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00411968S', 'ADRIAN ALBERTO', 'REJAS', 'PASTUN', to_date('02/11/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('25511174B', 'ANA', 'PAULA', 'BRANCO', to_date('01/22/1979', 'mm/dd/yyyy'), 'PL', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00087587', 'WAHUJ', 'JAVED', 'DESC', to_date('02/23/1979', 'mm/dd/yyyy'), 'PL', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00398686G', 'FREDERIK', 'ROEGIES', 'DESC', to_date('06/26/1978', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00407957Y', 'LAMO', 'QUETA', 'DESC', to_date('08/20/1980', 'mm/dd/yyyy'), 'PL', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('49610507J', 'WAIRA', 'RIVAS', 'RIOS', to_date('02/11/1985', 'mm/dd/yyyy'), 'PL', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('50314182W', 'GAEL JULIEN', 'LAVY', 'DESC', to_date('11/17/1985', 'mm/dd/yyyy'), 'PL', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00460189M', 'STEFANO', 'BARDUCCO', 'DESC', to_date('04/08/1979', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00400696J', 'NATALIYA', 'BERDNIKOVA', 'BEJARANO', to_date('03/14/1979', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00439921T', 'NEVILLE', 'PEALOZA', 'ALZATE', to_date('04/19/1979', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00382389Z', 'HANS', 'CONNOLLY', 'DESC', to_date('10/21/1979', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00024343', 'MIGUEL', 'ANGEL', 'LEDESMA', to_date('02/11/1979', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00512686Q', 'DIRK', 'OLIVER', 'LANGE', to_date('03/14/1956', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00388294P', 'RAMON', 'GARRIDO', 'RODRIGUEZ', to_date('02/22/1957', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00348309C', 'CARMEN', 'MARTINEZ', 'ACUNA', to_date('05/21/1957', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00107849', 'WAGNELL YUSEF', 'LOPEZ', 'RODRIGUEZ', to_date('05/21/1957', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00512688H', 'KATRIN', 'HERING', 'DESC', to_date('12/23/1979', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00422077G', 'GIOVANNI', 'BATISTA', 'MERELLO', to_date('07/18/1964', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T0566G644', 'FERNANDO', 'GRILLO', 'MARTINEZ', to_date('04/26/1979', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00356929S', 'CLEMENTINA', 'MAFUKA', 'DESC', to_date('06/13/1966', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00151028', 'WAGNER', 'COSTA', 'DA', to_date('11/05/1970', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00501296B', 'KATARINA', 'JANIKOVSKA', 'DESC', to_date('09/12/1972', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00509413D', 'VOLODYMYR', 'BERDNIKOV', 'DESC', to_date('02/07/1973', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00436819A', 'JOHANNA', 'MARIA', 'GUNNBERG', to_date('06/21/1975', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00481594C', 'LUDEK', 'RYBKA', 'DESC', to_date('10/10/1978', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('42957433B', 'CARINA', 'BASQUEZ', 'DESC', to_date('08/19/1982', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00133719', 'FRANCISCO', 'TORRENS', 'MARTIN', to_date('08/19/1982', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00507774A', 'PEDRO', 'JOSE', 'PERELLO', to_date('12/15/1988', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('42960232G', 'ROBERTO', 'SCIUTO', 'DESC', to_date('03/22/1993', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00503991S', 'MERCEDES', 'GRIMALT', 'ANGLADA', to_date('05/08/1995', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00397773B', 'ROMAN', 'ROMANOV', 'DESC', to_date('06/02/2004', 'mm/dd/yyyy'), 'IS', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00364641E', 'AMINAT', 'CHAMILEVA', 'DESC', to_date('12/15/1979', 'mm/dd/yyyy'), 'IS', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00511515H', 'MARINA', 'BASQUEZ', 'BASQUEZ', to_date('04/18/1978', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00454823K', 'SPIRIDON GEORGIOS', 'KAISARIS', 'DESC', to_date('11/13/1979', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00367326Q', 'LORENA', 'MINDEN', 'DESC', to_date('06/08/1979', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('55149210Z', 'ANDREA', 'FLORENCE', 'BRAUN', to_date('01/02/1979', 'mm/dd/yyyy'), 'LV', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00485359J', 'CHRISTINA', 'MATHILDE', 'LOEB', to_date('02/20/1979', 'mm/dd/yyyy'), 'LV', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00090949', 'ANNA', 'HELENA', 'HAAS', to_date('12/21/1979', 'mm/dd/yyyy'), 'LV', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43113966U', 'WILL', 'LARSON', NULL, to_date('03/26/1979', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41135685R', 'ROBERT', 'WALSER', 'DESC', to_date('11/23/1979', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00454822C', 'MARIA', 'EVGENIA', 'APOSTOLIDI', to_date('03/16/1976', 'mm/dd/yyyy'), 'LV', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00019774', 'WALTRAUD', 'SCHATZLE', 'DESC', to_date('12/28/1979', 'mm/dd/yyyy'), 'LV', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00446793H', 'KONSTANTINOS', 'KAISARIS', 'DESC', to_date('10/24/1979', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00365946Q', 'ASTON', 'PLACE', 'SIHOU', to_date('05/30/1954', 'mm/dd/yyyy'), 'LV', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00454287Z', 'CONSTANTINOS', 'CHAIDOUSIS', 'DESC', to_date('06/15/1954', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00093159', 'BERND', 'KUNO', 'SLOTTA', to_date('07/30/1969', 'mm/dd/yyyy'), 'LV', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41138834E', 'DANIELLE', 'ANNE', 'POGU', to_date('08/10/1970', 'mm/dd/yyyy'), 'LV', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('99382497F', 'JENS', 'ALBES', 'DESC', to_date('10/12/1979', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00365940X', 'JAKOB', 'EDUARD', 'Z', to_date('12/27/1979', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00415285C', 'AMADEUS', 'SCHIT', 'WOLFGANG', to_date('05/15/1971', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00416635J', 'EVELYN TARMANN', 'SCHMIDTER', NULL, to_date('09/25/1972', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00470813A', 'SIGRID', 'SCHERER', 'DESC', to_date('11/02/1973', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00459898J', 'SIMON', 'OMAR', 'GORGIA', to_date('03/25/1974', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00400449L', 'KARL HEINZ', 'MICHAEL', 'EIFERLE', to_date('12/17/1974', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00385957V', 'CHRISTINE', 'WOIDICH', 'DESC', to_date('03/12/1977', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00486173E', 'MELANIE', 'WACHTER', 'DESC', to_date('06/02/1978', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00477722N', 'SIMON', 'EDWARD', 'WARD', to_date('01/02/1979', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43113940A', 'SYLVANA GERTRAUD', 'JUNG', 'DESC', to_date('03/22/1982', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00379342A', 'SILVIA', 'JAHNKE', 'DESC', to_date('11/03/1982', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00501579H', 'CELIA MARY', 'WARD', 'DESC', to_date('03/01/1984', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00452720B', 'MARTIN', 'EBERL', 'DESC', to_date('05/30/1984', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('41330338M', 'MIYUKI', 'WADA', 'DESC', to_date('01/02/1994', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00360293K', 'LAURA', 'ROSA', 'OLIVERAS', to_date('10/30/1999', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00101556', 'WAI', 'WONG', 'YANG', to_date('10/17/2007', 'mm/dd/yyyy'), 'BE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00483268S', 'CHRISTOPH JOHANNES', 'HAGMANN', 'DESC', to_date('10/25/2011', 'mm/dd/yyyy'), 'BE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00120455', 'DEBORAH', 'MIRIAM', 'GOLDBLATT', to_date('04/28/1988', 'mm/dd/yyyy'), 'UK', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43137837A', 'CHRISTIAN', 'WILL', 'BACLAYEN', to_date('10/21/1992', 'mm/dd/yyyy'), 'UK', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('429813776', 'FRANCOIS', 'CLAUDE', 'REY', to_date('08/10/1977', 'mm/dd/yyyy'), 'UK', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00016910', 'MAX', 'KARL', 'HANSJORG', to_date('07/02/1983', 'mm/dd/yyyy'), 'UK', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('431378DFF', 'MARC', 'ANTOINE', 'BUGEJA', to_date('05/22/1986', 'mm/dd/yyyy'), 'UK', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00517421J', 'GORANA', 'HAIDOUSSI', 'DESC', to_date('02/22/2010', 'mm/dd/yyyy'), 'UK', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00016911', 'MONIKA', 'MARIE', 'JUNG', to_date('02/22/2010', 'mm/dd/yyyy'), 'UK', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00483269Q', 'KIRSTEN', 'HAGMANN', 'DESC', to_date('08/05/1979', 'mm/dd/yyyy'), 'UK', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00494866K', 'WINFRIED', 'OTTO', 'PFISTER', to_date('06/17/1979', 'mm/dd/yyyy'), 'UK', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00485007Y', 'STEFAN', 'REITENBACH', 'DESC', to_date('11/15/1979', 'mm/dd/yyyy'), 'UK', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00450194S', 'KARIN', 'ELISABETH', 'GIACOBBI', to_date('04/01/1979', 'mm/dd/yyyy'), 'UK', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00456191D', 'PHILIP', 'HUSAM', 'GORGIA', to_date('07/06/1928', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00456187M', 'BRIAN', 'ADRIAN', 'OUTTEN', to_date('04/10/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T00013632', 'MACIEK', 'WDOWIAK', 'DESC', to_date('02/04/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('T55529634', 'NOEL', 'CONNOLLY', 'DESC', to_date('04/22/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00374244B', 'WALTER', 'EHRHARDT', 'DESC', to_date('07/25/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('43149210Z', 'BERNDT', 'PETER', 'ANDBERG', to_date('10/02/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('4113883TY', 'HEINZ', 'WOLFGANG', 'SCHMID', to_date('02/12/1973', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00398057L', 'BERNADETTE', 'BANGURA', 'CHES', to_date('02/13/1946', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00238082D', 'LIDIA', 'ANA', 'PELLETTI', to_date('02/22/1946', 'mm/dd/yyyy'), 'DE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00407955G', 'JOSHUA', 'NICHOLAS', 'BEEK', to_date('06/21/1979', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00401512R', 'ANGELA', 'DOROTEA', 'MERKEL', to_date('12/07/1974', 'mm/dd/yyyy'), 'DE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00456193B', 'TIMOTHY', 'JOSEPH', 'OUTTEN', to_date('07/01/1960', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00456189F', 'YVONNE', 'BELINDA', 'OUTTEN', to_date('06/06/1967', 'mm/dd/yyyy'), 'DE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('22362211F', 'JIMENA', 'CASTRO', 'SOTELO', to_date('03/29/1977', 'mm/dd/yyyy'), 'DE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00503853S', 'JON', 'HALVORSEN', 'DESC', to_date('07/26/2000', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00381409T', 'MARKUS', NULL, 'BERGMAN', to_date('01/09/2003', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('10334143E', 'JAKOB', 'EBELL', 'AURUS', to_date('12/09/2006', 'mm/dd/yyyy'), 'DE', 'V',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('00382497F', 'EVELYN', 'SCHMID', 'TARMANN', to_date('04/11/2011', 'mm/dd/yyyy'), 'DE', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('42559836Y', 'JUAN', 'COSTA', 'PALOU', to_date('01/01/1980', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('77822365U', 'JAIME', 'CANTALLOPS', 'PONS', to_date('01/01/1980', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
ACT_PERSONA.PERSONAS_Add('11222333G', 'PERE', 'SERRA', 'MARTORELL', to_date('01/01/1980', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);

-- ************** AADIMOS 202 CIUDADANOS ASIGNADOS A PERSONAS  (Punto 1.1.4 documentacin)  ************** -- 
ACT_SALUD.CIUDADANOS_Add(7, 10, 'CSES0000000232', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(8, 10, 'CSES0000000234', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(9, 10, 'CSES0000000236', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(10, 10, 'CSES0000000238', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(11, 10, 'CSES0000000240', NULL, '759259025', 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(12, 10, 'CSES0000000242', ' ', NULL, 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(13, 10, 'CSES0000000244', ' ', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(14, 10, 'CSES0000000246', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(15, 10, 'CSES0000000248', NULL, NULL, 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(16, 10, 'CSES0000000250', '971259027', NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(105, 3, 'CSBE0000000600', ' ', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(169, 3, 'CSBE0000000531', '587259017', NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(170, 3, 'CSBE0000000533', '325259044', NULL, 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(171, 3, 'CSBE0000000535', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(172, 3, 'CSBE0000000537', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(173, 3, 'CSBE0000000539', '325259037', NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(174, 3, 'CSBE0000000541', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(175, 3, 'CSBE0000000543', NULL, '663259028', 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(176, 3, 'CSBE0000000545', '587259019', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(177, 3, 'CSBE0000000547', '325259038', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(178, 3, 'CSBE0000000549', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(179, 3, 'CSBE0000000551', '337675685', NULL, 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(180, 3, 'CSBE0000000553', '913259010', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(181, 3, 'CSBE0000000555', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(182, 3, 'CSBE0000000557', NULL, '663259030', 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(183, 3, 'CSBE0000000559', ' ', NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(184, 3, 'CSBE0000000561', '325259042', NULL, 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(185, 3, 'CSBE0000000563', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(186, 3, 'CSBE0000000565', '325259041', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(55, 5, 'CSCY0000000304', NULL, NULL, 'fic_mail@cied.rimed.cu ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(56, 5, 'CSCY0000000306', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(63, 5, 'CSCY0000000308', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(64, 5, 'CSCY0000000310', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(65, 5, 'CSCY0000000312', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(66, 5, 'CSCY0000000314', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(67, 5, 'CSCY0000000316', ' ', NULL, 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(68, 5, 'CSCY0000000318', NULL, NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(69, 5, 'CSCY0000000320', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(71, 5, 'CSCY0000000322', NULL, NULL, 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(72, 5, 'CSCY0000000324', NULL, NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(73, 5, 'CSCY0000000326', NULL, NULL, 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(74, 5, 'CSCY0000000328', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(75, 5, 'CSCY0000000330', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(76, 5, 'CSCY0000000332', NULL, NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(77, 5, 'CSCY0000000334', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(78, 5, 'CSCY0000000336', NULL, NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(79, 5, 'CSCY0000000338', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(80, 5, 'CSCY0000000340', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(81, 5, 'CSCY0000000342', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(82, 5, 'CSCY0000000344', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(83, 5, 'CSCY0000000346', ' ', NULL, 'fic_mail@cied.rimed.cu ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(84, 5, 'CSCY0000000348', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(85, 5, 'CSCY0000000350', NULL, NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(86, 5, 'CSCY0000000352', NULL, NULL, 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(87, 5, 'CSCY0000000354', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(88, 5, 'CSCY0000000356', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(89, 5, 'CSCY0000000358', NULL, NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(90, 5, 'CSCY0000000360', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(91, 5, 'CSCY0000000362', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(92, 5, 'CSCY0000000364', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(96, 5, 'CSCZ0000000241', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(100, 5, 'CSCZ0000000243', NULL, NULL, 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(101, 5, 'CSCZ0000000245', ' ', NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(102, 5, 'CSCZ0000000247', ' ', NULL, 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(103, 5, 'CSCZ0000000249', '338018349', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(107, 5, 'CSCZ0000000251', NULL, NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(111, 5, 'CSCZ0000000253', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(112, 5, 'CSCZ0000000255', ' ', NULL, 'fic_mail@cied.rimed.cu ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(119, 5, 'CSCZ0000000257', NULL, NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(99, 5, 'CSDE0000000700', '913259011', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(115, 5, 'CSDE0000000701', ' ', NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(118, 5, 'CSDE0000000702', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(122, 5, 'CSDE0000000703', '971259023', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(125, 5, 'CSDE0000000704', '663259027', NULL, 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(198, 5, 'CSDE0000000705', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(199, 5, 'CSDE0000000706', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(200, 5, 'CSDE0000000707', ' ', NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(201, 5, 'CSDE0000000708', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(202, 5, 'CSDE0000000709', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(203, 5, 'CSDE0000000710', '337856298', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(204, 5, 'CSDE0000000711', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(205, 5, 'CSDE0000000712', NULL, '663259026', 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(206, 5, 'CSDE0000000713', ' ', NULL, 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(207, 5, 'CSDE0000000714', NULL, '663259020', 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(208, 5, 'CSDE0000000715', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(209, 5, 'CSDE0000000716', NULL, NULL, 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(210, 5, 'CSDE0000000717', NULL, NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(211, 5, 'CSDE0000000718', ' ', NULL, 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(212, 5, 'CSDE0000000719', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(213, 5, 'CSDE0000000720', '913259013', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(94, 7, 'CSDK0000000110', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(17, 10, 'CSES0000000252', '971259022', NULL, 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(18, 10, 'CSES0000000254', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(19, 10, 'CSES0000000256', '325259040', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(20, 10, 'CSES0000000258', '971259024', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(21, 10, 'CSES0000000260', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(22, 10, 'CSES0000000262', NULL, NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(23, 10, 'CSES0000000264', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(24, 10, 'CSES0000000266', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(25, 10, 'CSES0000000268', '971259025', '759259022', 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(26, 10, 'CSES0000000270', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(27, 10, 'CSES0000000272', NULL, NULL, 'fic_mail@cied.rimed.cu ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(28, 10, 'CSES0000000274', '325259038', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(29, 10, 'CSES0000000276', NULL, NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(30, 10, 'CSES0000000278', '325259037', NULL, 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(31, 10, 'CSES0000000280', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(32, 10, 'CSES0000000282', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(33, 10, 'CSES0000000284', ' ', NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(34, 10, 'CSES0000000286', '325259043', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(35, 10, 'CSES0000000288', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(36, 10, 'CSES0000000290', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(37, 10, 'CSES0000000292', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(38, 10, 'CSES0000000294', '325259041', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(39, 10, 'CSES0000000296', '913259012', '759259022', 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(40, 10, 'CSES0000000298', ' ', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(41, 10, 'CSES0000000300', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(42, 10, 'CSES0000000302', NULL, NULL, 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(44, 10, 'CSES0000000304', '971259026', NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(45, 10, 'CSES0000000306', ' ', NULL, 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(46, 10, 'CSES0000000308', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(47, 10, 'CSES0000000310', NULL, '759259021', 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(48, 10, 'CSES0000000312', ' ', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(49, 10, 'CSES0000000314', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(50, 10, 'CSES0000000316', ' ', NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(129, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(130, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(131, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(132, 17, 'CSIS0000000850', '587259014', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(133, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(134, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(135, 17, 'CSIS0000000850', NULL, '759259020', 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(136, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(137, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(138, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(139, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(140, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@cied.rimed.cu ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(141, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(142, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(143, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(144, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(145, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(146, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(147, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(148, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(149, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(150, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(151, 17, 'CSIS0000000850', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(152, 17, 'CSIS0000000850', NULL, '759889025', 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(153, 17, 'CSIS0000000850', ' ', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(97, 17, 'CSIT0000000120', ' ', NULL, 'fic_mail@ idomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(104, 17, 'CSIT0000000121', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(108, 17, 'CSIT0000000122', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(154, 16, 'CSLV0000000213', '587259019', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(155, 16, 'CSLV0000000215', NULL, NULL, 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(156, 16, 'CSLV0000000217', '338193967', NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(157, 16, 'CSLV0000000219', NULL, '663259030', 'fic_mail@idiomas.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(158, 16, 'CSLV0000000221', '587259017', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(159, 16, 'CSLV0000000223', '971259024', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(160, 15, 'CSLV0000000225', NULL, '663259029', 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(161, 15, 'CSLV0000000227', NULL, '663259028', 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(162, 15, 'CSLV0000000229', NULL, NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(163, 15, 'CSLV0000000231', '971259023', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(164, 15, 'CSLV0000000233', '971259028', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(165, 15, 'CSLV0000000235', '337675685', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(166, 15, 'CSLV0000000237', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(167, 15, 'CSLV0000000239', '971259027', NULL, 'fic_mail@cied.rimed.cu ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(168, 15, 'CSLV0000000241', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(98, 15, 'CSPL0000000432', NULL, '759259023', 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(106, 15, 'CSPL0000000433', NULL, '759259024', 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(109, 12, 'CSPL0000000434', NULL, '759259022', 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(113, 10, 'CSPL0000000435', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(116, 10, 'CSPL0000000436', '587259018', NULL, 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(117, 10, 'CSPL0000000437', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(120, 10, 'CSPL0000000438', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(121, 10, 'CSPL0000000439', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(123, 10, 'CSPL0000000440', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(124, 10, 'CSPL0000000441', NULL, NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(126, 10, 'CSPL0000000442', '663259021', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(127, 10, 'CSPL0000000443', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(128, 10, 'CSPL0000000444', ' ', NULL, 'fic_mail@ubicar.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(51, 10, 'CSPT0000000445', NULL, '759259021', 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(52, 10, 'CSPT0000000446', NULL, NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(53, 10, 'CSPT0000000447', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(54, 10, 'CSPT0000000448', '337510614', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(57, 10, 'CSPT0000000449', ' ', NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(58, 10, 'CSPT0000000450', ' ', NULL, 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(59, 10, 'CSPT0000000451', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(60, 10, 'CSPT0000000452', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(61, 10, 'CSPT0000000453', NULL, NULL, 'fic_mail@idiomas.udea,edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(62, 10, 'CSPT0000000454', '325259039', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(110, 10, 'CSRO0000000765', '587259015', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(187, 14, 'CSUK0000000224', ' ', NULL, 'fic_mail@latinmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(188, 14, 'CSUK0000000256', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(189, 14, 'CSUK0000000288', ' ', NULL, 'fic_mail@yahoo.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(190, 14, 'CSUK0000000320', '913259010', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(191, 13, 'CSUK0000000352', ' ', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(192, 10, 'CSUK0000000384', '338360911', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(193, 10, 'CSUK0000000416', '913259011', NULL, 'fic_mail@hotmail.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(194, 11, 'CSUK0000000448', '325259042', NULL, 'fic_mail@cied.rimed.cu ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(195, 12, 'CSUK0000000480', '338193967', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(196, 12, 'CSUK0000000512', '325259044', NULL, 'fic_mail@epm.net.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
ACT_SALUD.CIUDADANOS_Add(197, 12, 'CSUK0000000544', NULL, '663259029', 'fic_mail@terra.com ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
END;


